<?php
/*********************************************************************************
 * The contents of this file are subject to the TimeTrex Public License Version
 * 1.1.0 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.TimeTrex.com/TPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by TimeTrex" logo and
 *    (ii) the TimeTrex copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: TimeTrex Open Source
 * The Initial Developer of the Original Code is TimeTrex Payroll Services
 * Portions created by TimeTrex are Copyright (C) 2004-2007 TimeTrex Payroll Services;
 * All Rights Reserved.
 *
 ********************************************************************************/
/*
 * $Revision: 4 $
 * $Id: ViewPDFROE.php 4 2006-08-07 23:04:34Z ipso $
 * $Date: 2006-08-07 16:04:34 -0700 (Mon, 07 Aug 2006) $
 */
require_once('../../includes/global.inc.php');
require_once(Environment::getBasePath() .'includes/Interface.inc.php');
require(Environment::getBasePath() .'/classes/fpdf/fpdf.php');

if ( !$permission->Check('roe','enabled')
		OR !( $permission->Check('roe','view') OR $permission->Check('roe','view_own') ) ) {

	$permission->Redirect( FALSE ); //Redirect

}


$title = 'Record Of Employment';
$smarty->assign('title', $title );
BreadCrumb::setCrumb($title);
/*
 * Get FORM variables
 */
extract	(FormVariables::GetVariables(
										array	(
												'action',
												'page',
												'sort_column',
												'sort_order',
												'print',
												'id',
												'ids'
												) ) );

switch (strtolower($action)) {
	default:
		if ( isset($id) AND !isset($ids) ) {
			$ids = array($id);
		}

		$border = 0;

		$ppsf = new PayPeriodScheduleListFactory();
		$pay_period_type_options = $ppsf->getOptions('type');

		//Monthly+Advance is the same as Monthly.
		$pay_period_type_options[40] = $pay_period_type_options[50];

		foreach ($ids as $id) {
			$roelf = new ROEListFactory();

			$roelf->getById( $id );

			if ( $roelf->getRecordCount() > 0 ) {
				$roe = $roelf->getCurrent();
/*
				$roe_data = array(
									'id' => $roe->getId(),
									'user_id' => $roe->getUser(),
									'pay_period_type_id' => $roe->getPayPeriodType(),
									'pay_period_type' => $pay_period_type_options[$roe->getPayPeriodType()],
									'code_id' => $roe->getCode(),
									'first_date' => $roe->getFirstDate(),
									'first_date_arr' => getdate( $roe->getFirstDate() ),

									'last_date' => $roe->getLastDate(),
									'last_date_arr' => getdate( $roe->getLastDate() ),

									'pay_period_end_date' => $roe->getPayPeriodEndDate(),
									'pay_period_end_date_arr' => getdate( $roe->getPayPeriodEndDate() ),

									'recall_date' => $roe->getRecallDate(),
									'recall_date_arr' => getdate( $roe->getRecallDate() ),

									'insurable_hours' => $roe->getInsurableHours(),
									'insurable_earnings' => $roe->getInsurableEarnings(),
									'vacation_pay' => $roe->getVacationPay(),
									'serial' => $roe->getSerial(),
									'comments' => $roe->getComments(),
									'created_date' => $roe->getCreatedDate(),
									'created_date' => $roe->getCreatedDate(),
									'created_date_arr' => getdate( $roe->getCreatedDate() ),

									'created_by' => $roe->getCreatedBy(),
									'updated_date' => $roe->getUpdatedDate(),
									'updated_by' => $roe->getUpdatedBy(),
									'deleted_date' => $roe->getDeletedDate(),
									'deleted_by' => $roe->getDeletedBy()
								);
*/
				//Get User information
				$ulf = new UserListFactory();
				$user_obj = $ulf->getById( $roe->getUser() )->getCurrent();

				$ulf = new UserListFactory();
				$created_user_obj = $ulf->getById( $roe->getCreatedBy() )->getCurrent();

				//Get company information
				$clf = new CompanyListFactory();
				$company_obj = $clf->getById( $user_obj->getCompany() )->getCurrent();

				$pdf = new FPDF();
				$pdf->setMargins(0,0,0,0);
				$pdf->SetAutoPageBreak(FALSE);
				$pdf->SetFont('Arial','',12);

				$pdf->AddPage();

				if ( $print == 0 ) {
					$pdf->Image(Environment::getImagesPath() .'roe-template.jpg',0,0,210,300);
				}

				//Serial
				$pdf->setXY(10,17);
				$pdf->Cell(55,10,$roe->getSerial(), $border, 0, 'L');

				//Employer Info
				$pdf->setXY(10,30);
				$pdf->Cell(120,10,$company_obj->getName(), $border, 0, 'L');

				$pdf->setXY(10,40);
				$pdf->Cell(120,10,$company_obj->getAddress1().' '.$company_obj->getAddress2(), $border, 0, 'L');

				$pdf->setXY(10,50);
				$pdf->Cell(90,10,$company_obj->getCity().', '.$company_obj->getProvince(), $border, 0, 'L');

				$postal_code_a = substr($company_obj->getPostalCode(), 0, 3);
				$postal_code_b = substr($company_obj->getPostalCode(), 3, 6);

				$pdf->setXY(110,50);
				$pdf->Cell(10,10,$postal_code_a, $border, 0, 'L');

				$pdf->setXY(122,50);
				$pdf->Cell(10,10,$postal_code_b, $border, 0, 'L');

				//Business Number
				$pdf->setXY(138,28);
				$pdf->Cell(120,10,$company_obj->getBusinessNumber(), $border, 0, 'L');

				//Pay Period Type
				$pdf->setXY(138,40);
				$pdf->Cell(50,10, $pay_period_type_options[$roe->getPayPeriodType()], $border, 0, 'L');

				//SIN
				$pdf->setXY(138,50);
				$pdf->Cell(50,10,$user_obj->getSIN(), $border, 0, 'L');

				//Employee info
				$pdf->SetFontSize(10);
				$pdf->setXY(10,75);
				$pdf->Cell(90,5,$user_obj->getFullName(), $border, 0, 'L');

				$pdf->setXY(10,80);
				$pdf->Cell(90,5,$user_obj->getAddress1().' '.$user_obj->getAddress2(), $border, 0, 'L');

				$pdf->setXY(10,85);
				$pdf->Cell(90,5,$user_obj->getCity().', '.$user_obj->getProvince() .' '. $user_obj->getPostalCode() , $border, 0, 'L');

				$pdf->SetFontSize(12);

				//Employee Title
				if ( is_object($user_obj->getTitleObject() ) ) {
					$title = $user_obj->getTitleObject()->getName();
				} else {
					$title = NULL;
				}
				$pdf->setXY(10,100);
				$pdf->Cell(90,10, $title, $border, 0, 'L');

				//First Day Worked
				$pdf->SetFontSize(10);
				$first_date = getdate( $roe->getFirstDate() );
				$pdf->setXY(175,64);
				$pdf->Cell(8,10, $first_date['mday'], $border, 0, 'C');
				$pdf->setXY(185,64);
				$pdf->Cell(8,10, $first_date['mon'], $border, 0, 'C');
				$pdf->setXY(196,64);
				$pdf->Cell(10,10, $first_date['year'], $border, 0, 'C');

				//Last day paid
				$last_date = getdate( $roe->getLastDate() );
				$pdf->setXY(175,75);
				$pdf->Cell(8,10, $last_date['mday'], $border, 0, 'C');
				$pdf->setXY(185,75);
				$pdf->Cell(8,10, $last_date['mon'], $border, 0, 'C');
				$pdf->setXY(196,75);
				$pdf->Cell(10,10, $last_date['year'], $border, 0, 'C');

				//Pay Period End Date
				$pay_period_end_date = getdate( $roe->getPayPeriodEndDate() );
				$pdf->setXY(175,86);
				$pdf->Cell(8,10, $pay_period_end_date['mday'], $border, 0, 'C');
				$pdf->setXY(185,86);
				$pdf->Cell(8,10, $pay_period_end_date['mon'], $border, 0, 'C');
				$pdf->setXY(196,86);
				$pdf->Cell(10,10, $pay_period_end_date['year'], $border, 0, 'C');

				//Insurable Hours
				$pdf->SetFontSize(10);
				$pdf->setXY(75,113);
				$pdf->Cell(25,10, Misc::getBeforeDecimal( $roe->getInsurableHours() ), $border, 0, 'R');

				$pdf->setXY(101,113);
				$pdf->Cell(10,10, Misc::getAfterDecimal( Misc::MoneyFormat( $roe->getInsurableHours(), FALSE ) ), $border, 0, 'L');

				//Enter Code
				$pdf->setXY(185,113);
				$pdf->Cell(10,10, $roe->getCode(), $border, 0, 'C');

				//Further Information Contact Name
				$pdf->setXY(130,126);
				$pdf->Cell(75,5, $created_user_obj->getFullName() , $border, 0, 'R');
				$pdf->setXY(130,132);
				$pdf->Cell(75,10, $created_user_obj->getWorkPhone() , $border, 0, 'R');

				//Insurable Earnings
				$pdf->setXY(75,131);
				$pdf->Cell(25,10, Misc::getBeforeDecimal( $roe->getInsurableEarnings() ), $border, 0, 'R');

				$pdf->setXY(101,131);
				$pdf->Cell(10,10, Misc::getAfterDecimal( Misc::MoneyFormat( $roe->getInsurableEarnings(), FALSE ) ), $border, 0, 'L');

				//English
				$pdf->setXY(8.5,256.5);
				$pdf->Cell(10,10, 'X', $border, 0, 'L');

				//ROE creator phone number
				$pdf->setXY(75,258);
				$pdf->Cell(25,10, $created_user_obj->getWorkPhone() , $border, 0, 'L');

				//ROE create name.
				$pdf->SetFontSize(12);
				$pdf->setXY(87,273);
				$pdf->Cell(75,10, $created_user_obj->getFullName() , $border, 0, 'C');

				//Create Date
				$created_date = getdate( $roe->getCreatedDate() );
				$pdf->SetFontSize(10);
				$pdf->setXY(175,273);
				$pdf->Cell(8,10, $created_date['mday'] , $border, 0, 'C');

				$pdf->setXY(185,273);
				$pdf->Cell(8,10, $created_date['mon'] , $border, 0, 'C');

				$pdf->setXY(195,273);
				$pdf->Cell(10,10, $created_date['year'] , $border, 0, 'C');

				$output = $pdf->Output('','S');
				Misc::FileDownloadHeader('roe.pdf', 'application/pdf', strlen($output));
				echo $output;
			}

/*
			if ( $roelf->getRecordCount() > 0 ) {
				$roe = $roelf->getCurrent();

				$roe_data = array(
									'id' => $roe->getId(),
									'user_id' => $roe->getUser(),
									'pay_period_type_id' => $roe->getPayPeriodType(),
									'pay_period_type' => $pay_period_type_options[$roe->getPayPeriodType()],
									'code_id' => $roe->getCode(),
									'first_date' => $roe->getFirstDate(),
									'first_date_arr' => getdate( $roe->getFirstDate() ),

									'last_date' => $roe->getLastDate(),
									'last_date_arr' => getdate( $roe->getLastDate() ),

									'pay_period_end_date' => $roe->getPayPeriodEndDate(),
									'pay_period_end_date_arr' => getdate( $roe->getPayPeriodEndDate() ),

									'recall_date' => $roe->getRecallDate(),
									'recall_date_arr' => getdate( $roe->getRecallDate() ),

									'insurable_hours' => $roe->getInsurableHours(),
									'insurable_earnings' => $roe->getInsurableEarnings(),
									'vacation_pay' => $roe->getVacationPay(),
									'serial' => $roe->getSerial(),
									'comments' => $roe->getComments(),
									'created_date' => $roe->getCreatedDate(),
									'created_date' => $roe->getCreatedDate(),
									'created_date_arr' => getdate( $roe->getCreatedDate() ),

									'created_by' => $roe->getCreatedBy(),
									'updated_date' => $roe->getUpdatedDate(),
									'updated_by' => $roe->getUpdatedBy(),
									'deleted_date' => $roe->getDeletedDate(),
									'deleted_by' => $roe->getDeletedBy()
								);

				//Get User information
				$ulf = new UserListFactory();
				$user_obj = $ulf->getById( $roe->getUser() )->getCurrent();

				$ulf = new UserListFactory();
				$created_user_obj = $ulf->getById( $roe->getCreatedBy() )->getCurrent();

				//Get company information
				$clf = new CompanyListFactory();
				$company_obj = $clf->getById( $user_obj->getCompany() )->getCurrent();
			}

			$smarty->assign_by_ref('roe', $roe_data);

			$smarty->assign_by_ref('company_obj', $company_obj);
			$smarty->assign_by_ref('user_obj', $user_obj);
			$smarty->assign_by_ref('created_user_obj', $created_user_obj);

			$smarty->assign_by_ref('print', $print);
			if ( $print == 1) {
				$print_offset = 2;
			} else {
				$print_offset = 0;
			}
			//$print_offset=2;
			$smarty->assign_by_ref('print_offset', $print_offset);

			$pdf=new FPDF();
			$pdf->AddPage();
			$pdf->Image(Environment::getBasePath().'interface/images/roe-template.jpg',0,0,210,300);
			$pdf->SetFont('Arial','B',12);
			$pdf->setXY(10,17);
			$pdf->Cell(55,10,'Hello World! Loooooooooooooooooooong', 1, 0, 'L');
			$pdf->Output();

			//$roe_html[$id] = $smarty->fetch('roe/ViewPDFROE.tpl');

			//$smarty->display('roe/ViewPDFROE.tpl');
			//exit;
*/
		}

		break;
}
/*
$dir = '/tmp/'.uniqid('roe_').'/';
mkdir( $dir );
foreach ($roe_html as $id => $data) {
	$filename = $dir.'/'.$id;
	//echo "FileName: $filename<br>\n";
	if ( file_put_contents($filename.'.html', $data) > 0 ) {
		//echo "Writing file successfull<Br>\n";
	} else {
		//echo "Error writing file<Br>\n";
		exit;
	}
}

//Convert to PDF
//
//	REPLACE the body image before goign LIVE!!
//
if ( $print == 1 ) {
	$cmd = 'htmldoc --no-title --footer . --left 0mm --right 0mm --bottom 0mm --top 0mm -f '. $dir .'out.pdf --webpage '. $dir .'*.html';
} else {
	$cmd = 'htmldoc --no-title --footer . --left 0mm --right 0mm --bottom 0mm --top 0mm --bodyimage '.Environment::getBasePath().'interface/images/roe-template.jpg -f '. $dir .'out.pdf --webpage '. $dir .'*.html';
}
//echo "Cmd: $cmd<br>\n";
exec($cmd, $output, $retval);
unset($output);
//echo "Retval: $retval<br>\n";

//Open PDF and display
$pdf = file_get_contents($dir.'out.pdf');
if ($pdf === FALSE) {
	//echo "Error reading PDF<br>\n";
	exit;
}

Misc::FileDownloadHeader('roe.pdf', 'application/pdf', strlen($pdf));
echo $pdf;

//Delete tmp files.
foreach(glob($dir.'*') as $filename) {
	unlink($filename);
}
rmdir($dir);
*/
//Debug::Display();
?>